/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Point;
	import com.llops.utils.Random;
	
	public class Main extends Sprite
	{		
		// MC en el escenario
		public var limpiar_mc:MovieClip;
		
		// Medidas escenario
		public static var ANCHO:int = 300;
		public static var ALTO:int = 150;
		private var _margen:int = 20;
		
		// Bitmap
		private var _bmpData:BitmapData = new BitmapData(ANCHO-_margen,ALTO-_margen,false,0x6699CC);
		private var _bmp:Bitmap = new Bitmap(_bmpData);
		
		// Variable que permite o no pintar
		private var _pintar_activo:Boolean = false;
		
		function Main() 
		{	
			// Ajustamos el bitmap
			_bmp.x = _margen/2;
			_bmp.y = _margen/2;
			addChild(_bmp);
			
			// Poner el MC limpiar por encima del bitmap
			addChild(limpiar_mc);
			
			// Eventos
			stage.addEventListener(MouseEvent.MOUSE_DOWN, function():void { _pintar_activo = true } );
			stage.addEventListener(MouseEvent.MOUSE_UP, function():void { _pintar_activo = false } );
			stage.addEventListener(Event.ENTER_FRAME, pintar);
			limpiar_mc.addEventListener(MouseEvent.CLICK, limpiarCanvas);
		}
		
		private function pintar(e:Event):void 
		{
			// Si se puede pintar...
			if (_pintar_activo)
			{
				// Cogemos las coordenas del mouse
				var p_mouse:Point = new Point(_bmp.mouseX, _bmp.mouseY);
				
				for (var i:int = 0; i < 25; i++) 
				{
					// Cogemos un punto aleatorio
					var p:Point = Random.obtenerPuntoCirculo(p_mouse,10);
					
					// Pintamos el pixel en la posicion obtenida
					_bmpData.setPixel(p.x, p.y, 0xFFCC99);
				}
			}
		}
		
		private function limpiarCanvas(e:MouseEvent):void 
		{
			_bmpData.fillRect(_bmpData.rect, 0x6699CC);
		}
	}
}